<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="规格名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入规格名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['product:rule:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['product:rule:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['product:rule:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['product:rule:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="ruleList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="规格名称" align="center" prop="name" />
      <el-table-column label="属性名称" align="center" >
        <template slot-scope="scope">
          <el-row  v-for="attr in scope.row.ruleAttrList">
            <span onresize="mini">{{attr.attrName}}</span>
          </el-row>
        </template>
      </el-table-column>
      <el-table-column label="属性值" align="center" >
        <template slot-scope="scope">
          <el-row  v-for="attr in scope.row.ruleAttrList">
            <span>{{attr.valueList.toString()}}</span>
          </el-row>
        </template>
      </el-table-column>
      <el-table-column label="是否启用" align="center" prop="states" >
      <template slot-scope="scope">
        <dict-tag :options="dict.type.sys_yes_no" :value="scope.row.states"/>
      </template>
      </el-table-column>
      <el-table-column label="说明" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['product:rule:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['product:rule:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改规格对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="80%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-row>
          <el-col :span="12">
            <el-form-item label="规格名称" prop="name">
              <el-input v-model="form.name" placeholder="请输入规格名称" />
            </el-form-item>
            <el-form-item label="状态" prop="states">
              <el-radio-group v-model="form.states">
                <el-radio
                  v-for="dict in dict.type.sys_yes_no"
                  :key="dict.value"
                  :label="dict.value"
                >{{dict.label}}</el-radio>
              </el-radio-group>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="说明" prop="remark">
              <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row v-for="(ruleAttr,index) in form.ruleAttrList">
              <el-tag
                :key="ruleAttr.attrName"
                closable
                @close="removeRule(index)">
                {{ruleAttr.attrName}}
              </el-tag>

            <el-row style="margin: 10px 0">
              <el-tag
                style="float:left;margin-right: 20px"
                v-for="(ruleProperty,index) in ruleAttr.valueList"
                :key="ruleProperty"
                @close="removeRuleProperty(ruleAttr.valueList,index)"
                closable>
                {{ruleProperty}}
              </el-tag>
              <el-button
                v-if="!ruleAttr.ruleAttrAddStatus"
                         @click="ruleAttr.ruleAttrAddStatus = !ruleAttr.ruleAttrAddStatus"
                         size="mini">添加</el-button>
              <el-input v-if="ruleAttr.ruleAttrAddStatus"
                        v-model="addRulePropertyValue"
                        @blur="addRuleProperty(ruleAttr,false)"
                        @keyup.enter.native="addRuleProperty(ruleAttr,true)"
                        size="mini" placeholder="请输入规格属性值"
                        style="float: left; width: 150px"/>
              <el-button size="mini" v-if="ruleAttr.ruleAttrAddStatus" @click="ruleAttr.ruleAttrAddStatus = !ruleAttr.ruleAttrAddStatus">取消</el-button>
            </el-row>

            <el-divider></el-divider>
        </el-row>
          <el-button v-if="!ruleAddStatus" @click="ruleAddStatus = !ruleAddStatus">添加规格</el-button>
        <el-form v-if="ruleAddStatus" :inline="true" :model="ruleAddForm" class="demo-form-inline">
          <el-form-item label="规格名称">
            <el-input v-model="ruleAddForm.name" placeholder="请输入规格名称"></el-input>
          </el-form-item>
          <el-form-item label="规格属性">
            <el-input v-model="ruleAddForm.valueList" placeholder="请输入规格属性"></el-input>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="ruleAddFormFun" v-if="ruleAddStatus">添加</el-button>
            <el-button type="primary" @click="ruleAddStatus = !ruleAddStatus">取消</el-button>
          </el-form-item>
        </el-form>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listRule, getRule, delRule, addRule, updateRule } from "@/api/product/rule";

export default {
  name: "Rule",
  dicts: ['sys_yes_no'],
  data() {
    return {
      ruleAddStatus: false,
      ruleAddForm: {
        name: null,
        valueList: null,
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 规格表格数据
      ruleList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
      },
      // 表单参数
      form: {},
      addRulePropertyValue: null,
      // 表单校验
      rules: {
        name: [
          { required: true, message: "规格名称不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    addRuleList() {
        this.ruleAddFormStatus = false;

    },
    removeRule(index){
      this.form.ruleAttrList.splice(index, 1);
    },
    removeRuleProperty(valueList,index){
      valueList.splice(index, 1);
    },
    addRuleProperty(ruleAttr, continuousInput){
      if (this.addRulePropertyValue === null || this.addRulePropertyValue === 0){
        if (!continuousInput){
          ruleAttr.ruleAttrAddStatus = !ruleAttr.ruleAttrAddStatus
        }
        return;
      }
      console.log(ruleAttr)
      if (ruleAttr.valueList.indexOf(this.addRulePropertyValue) > -1){
        this.$message({
          message: `规格[${ruleAttr.name}]属性值[${this.addRulePropertyValue}]已经存在`,
          type: 'warning'
        });
        return;
      }
      ruleAttr.valueList.push(this.addRulePropertyValue)
      this.addRulePropertyValue = null;
      if (!continuousInput){
        ruleAttr.ruleAttrAddStatus = !ruleAttr.ruleAttrAddStatus
      }
    },
    ruleAddFormFun(){
      if (this.ruleAddForm.name === null || this.ruleAddForm.name.length === 0){
        this.$message({
          message: '规格名称不可为空',
          type: 'warning'
        });
        return;
      }
      if (this.ruleAddForm.valueList === null || this.ruleAddForm.valueList.length === 0){
        this.$message({
          message: '规格属性不可为空',
          type: 'warning'
        });
        return;
      }
      let ruleAttr = this.form.ruleAttrList.find(ruleAttr => ruleAttr.name === this.ruleAddForm.name);
      if (ruleAttr === undefined){
        this.form.ruleAttrList.push({
          "attrName": this.ruleAddForm.name,
          "valueList": [this.ruleAddForm.valueList],
          "ruleAttrAddStatus": false
        })
      }else {
        if (ruleAttr.valueList.indexOf(this.ruleAddForm.valueList) > -1){
          this.$message({
            message: `规格[${this.ruleAddForm.name}]属性值[${this.ruleAddForm.valueList}]已经存在`,
            type: 'warning'
          });
          return;
        }
        ruleAttr.valueList.push(this.ruleAddForm.valueList)
      }
      this.ruleAddForm = {
        name: null,
        valueList: null,
      }
      this.ruleAddStatus = false;
    },
    /** 查询规格列表 */
    getList() {
      this.loading = true;
      listRule(this.queryParams).then(response => {
        console.log(response)
        this.ruleList = response.data.rows;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        remark: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        ruleAttrList: [],
        asInsertRule: [],
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加规格";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getRule(id).then(response => {
        console.log(response)
        this.form = response.data;
        this.open = true;
        this.title = "修改规格";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateRule(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRule(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除规格编号为"' + ids + '"的数据项？').then(function() {
        return delRule(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('product/rule/export', {
        ...this.queryParams
      }, `rule_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
